﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace App37.mt
{
  public class FlexGrid
  {
    public static readonly DependencyProperty DefinitionsProperty = DependencyProperty.RegisterAttached(
      "Layout", typeof(FlexGridLayout), typeof(Grid), new PropertyMetadata(null, OnDefinitionsChanged));

    public static FlexGridLayout GetLayout(Grid target)
    {
      FlexGridLayout definitions = (FlexGridLayout)target.GetValue(DefinitionsProperty);

      if (definitions == null)
      {
        target.SetValue(DefinitionsProperty, new FlexGridLayout());
      }
      return ((FlexGridLayout)target.GetValue(DefinitionsProperty));
    }
    public static void SetLayout(Grid target, FlexGridLayout value)
    {
      target.SetValue(DefinitionsProperty, value);
    }
    static void OnDefinitionsChanged(DependencyObject sender, DependencyPropertyChangedEventArgs value)
    {
      if (value.NewValue != null)
      {
        FlexGridLayout layout = (FlexGridLayout)value.NewValue;
        layout.SetAssociatedGrid((Grid)sender);
      }
      else
      {
        FlexGridLayout layout = (FlexGridLayout)value.OldValue;

        if (layout != null)
        {
          layout.ClearAssociatedGrid();
        }
      }
    }
  }
}